﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections.ObjectModel;
using DeleteRecord.Model;
using System.Windows.Input;
using DeleteRecord.Classes;

namespace DeleteRecord.ViewModel
{
    class GridViewModel : ViewModelBase
    {

        ObservableCollection<Customer> infos;
        ICommand _command;

        public GridViewModel()
        {
           CustomerInfo = new ObservableCollection<Customer>();
           CustomerInfo.Add(new Customer
             {
                 FirstName = "Jon",
                 LastName = "Smith",
                 Age = 24,
                 DateOfBirth = new DateTime(1987, 4, 29),
             });
           CustomerInfo.Add(new Customer
             {
                 FirstName = "Valentina",
                 LastName = "Metrace",
                 Age = 23,
                 DateOfBirth = new DateTime(1988, 3, 4),
             });
           CustomerInfo.Add(new Customer
             {
                 FirstName = "Randy",
                 LastName = "Russel",
                 Age = 26,
                 DateOfBirth = new DateTime(1985, 10, 2),
             });
           CustomerInfo.Add(new Customer
             {
                 FirstName = "Nathaniel",
                 LastName = "Klein",
                 Age = 28,
                 DateOfBirth = new DateTime(1983, 5, 7),
             });
           CustomerInfo.Add(new Customer
             {
                 FirstName = "Gregory",
                 LastName = "Smyslov",
                 Age = 26,
                 DateOfBirth = new DateTime(1985, 11, 20),
             });
           CustomerInfo.Add(new Customer
             {
                 FirstName = "Samuel",
                 LastName = "Castilla",
                 Age = 22,
                 DateOfBirth = new DateTime(1989, 1, 27),
             });
           CustomerInfo.Add(new Customer
             {
                 FirstName = "Peter",
                 LastName = "Howell",
                 Age = 21,
                 DateOfBirth = new DateTime(1990, 8, 6),
             });
           CustomerInfo.Add(new Customer
             {
                 FirstName = "Marty",
                 LastName = "Zellerbach",
                 Age = 23,
                 DateOfBirth = new DateTime(1988, 9, 9),
             });
           CustomerInfo.Add(new Customer
             {
                 FirstName = "Jason",
                 LastName = "Bourne",
                 Age = 24,
                 DateOfBirth = new DateTime(1987, 10, 18),
             });
           CustomerInfo.Add(new Customer
             {
                 FirstName = "Alexander",
                 LastName = "Conklin",
                 Age = 21,
                 DateOfBirth = new DateTime(1990, 11, 27),
             });
        }

        public ObservableCollection<Customer> CustomerInfo
        {
            get
            {
                return infos;
            }
            set
            {
                infos = value;
                OnPropertyChanged("CustomerInfo");
            }
        }

        public ICommand RemoveCommand
        {
            get
            {
                if (_command == null)
                {
                    _command = new DelegateCommand(CanExecute, Execute);
                }
                return _command;
            }
        }

        private void Execute(object parameter)
        {
            int index = CustomerInfo.IndexOf(parameter as Customer);
            if (index > -1 && index < CustomerInfo.Count)
            {
                CustomerInfo.RemoveAt(index);
            }
        }

        private bool CanExecute(object parameter)
        {
            return true;
        }
    }
}
